Index: LMDZ4/trunk/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/phys_output_mod.F90	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/phys_output_mod.F90	(revision 996)
@@ -188,12 +188,5 @@
   integer, dimension(nfiles) , save :: flag_philevsSTD   = (/ 1, 1, 1, 10 /)
 
-  integer, dimension(nfiles) , save :: flag_fluxo        = (/ 1, 1, 10, 10 /)
-  integer, dimension(nfiles) , save :: flag_fluxg        = (/ 1, 1, 10, 10 /)
   integer, dimension(nfiles) , save :: flag_t_oce_sic    = (/ 1, 10, 10, 10 /)
-
-  integer, dimension(nfiles) , save :: flag_lmt_bils     = (/ 1, 1, 10, 10 /)
-  integer, dimension(nfiles) , save :: flag_tslab        = (/ 1, 1, 10, 10 /)
-  integer, dimension(nfiles) , save :: flag_seaice       = (/ 1, 1, 10, 10 /)
-  integer, dimension(nfiles) , save :: flag_siceh        = (/ 1, 1, 10, 10 /)
 
   integer, dimension(nfiles) , save :: flag_weakinv      = (/ 10, 1, 10, 10 /)
@@ -590,18 +583,8 @@
        ENDDO
 
-!IM diagnostiques flux ocean-atm ou ocean-glace de mer
-!IM pour utilisation dans un modele de "slab" ocean
- CALL histdef2d(iff,flag_fluxo,"fluxo","Flux turbulents ocean-atmosphere","W/m2")
- CALL histdef2d(iff,flag_fluxg,"fluxg","Flux turbulents ocean-glace de mer","W/m2")
  CALL histdef2d(iff,flag_t_oce_sic,"t_oce_sic","Temp mixte oce-sic","K")
 
-     IF (OCEAN.EQ.'force ') THEN
- CALL histdef2d(iff,flag_lmt_bils,"lmt_bils","Bilan au sol atmosphere forcee","W/m2")
-     ELSE IF (OCEAN.EQ.'slab  ') THEN
- CALL histdef2d(iff,flag_slab_bils,"slab_bils","Bilan au sol Slab","W/m2") 
- CALL histdef2d(iff,flag_tslab,"tslab", "Slab SST ", "K")
- CALL histdef2d(iff,flag_seaice,"seaice","Slab seaice","kg/m2") 
- CALL histdef2d(iff,flag_siceh,"siceh","Slab seaice height","m")
-     ENDIF
+ IF (ocean=='slab') & 
+      CALL histdef2d(iff,flag_slab_bils, "slab_wbils_oce","Bilan au sol sur ocean slab", "W/m2")
 
  CALL histdef2d(iff,flag_ale_bl,"ale_bl","ALE BL","m2/s2") 
Index: LMDZ4/trunk/libf/phylmd/phys_output_write.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/phys_output_write.h	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/phys_output_write.h	(revision 996)
@@ -41,5 +41,5 @@
        IF (flag_contfracOR(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),"contfracOR",itau_w,
-     $                   pctsrf_new(:,is_ter))
+     $                   pctsrf(:,is_ter))
        ENDIF
 
@@ -599,29 +599,4 @@
        ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.
        ENDDO
-
-!IM diagnostiques flux ocean-atm ou ocean-glace de mer
-!IM pour utilisation dans un modele de "slab" ocean
-
-      IF (flag_fluxo(iff)<=lev_files(iff)) THEN
-      DO i=1, klon
-       IF (pctsrf(i,is_oce).GT.epsfra) THEN
-        zx_tmp_fi2d(i) = fluxo(i)
-       ELSE
-        zx_tmp_fi2d(i) = 0.
-       ENDIF
-      ENDDO
-      CALL histwrite_phy(nid_files(iff),"fluxo",itau_w,zx_tmp_fi2d)
-      ENDIF
-
-      IF (flag_fluxg(iff)<=lev_files(iff)) THEN
-      DO i=1, klon
-       IF (pctsrf(i,is_sic).GT.epsfra) THEN
-        zx_tmp_fi2d(i) = fluxg(i)
-       ELSE
-        zx_tmp_fi2d(i) = 0.
-       ENDIF
-      ENDDO
-      CALL histwrite_phy(nid_files(iff),"fluxg",itau_w,zx_tmp_fi2d)
-      ENDIF
 
       IF (flag_t_oce_sic(iff)<=lev_files(iff)) THEN
@@ -639,17 +614,5 @@
       ENDIF
 
-      IF (OCEAN.EQ.'force ') THEN
-      IF (flag_lmt_bils(iff)<=lev_files(iff)) THEN
-      DO i=1, klon
-      IF((pctsrf(i,is_oce).GT.epsfra).OR.
-     $   (pctsrf(i,is_sic).GT.epsfra)) THEN
-       zx_tmp_fi2d(i) = (radsol(i) + fluxo(i))*pctsrf(i,is_oce)+
-     $                  fluxg(i)*pctsrf(i,is_sic)
-      ELSE
-       zx_tmp_fi2d(i) = 1.E+20
-      ENDIF
-      ENDDO
-      CALL histwrite_phy(nid_files(iff),"lmt_bils",itau_w,zx_tmp_fi2d)
-      ENDIF
+      IF (type_ocean=='force ') THEN
 
       IF (iflag_coupl.EQ.1) THEN
@@ -683,40 +646,12 @@
        ENDIF
       ENDIF
-
-      ELSE IF (OCEAN.EQ.'slab  ') THEN
-
-      IF (flag_slab_bils(iff)<=lev_files(iff)) THEN
-      DO i=1, klon
-      IF((pctsrf(i,is_oce).GT.epsfra).OR.
-     $   (pctsrf(i,is_sic).GT.epsfra)) THEN
-       zx_tmp_fi2d(i) = (radsol(i) + fluxo(i))*pctsrf(i,is_oce)+
-     $                  fluxg(i)*pctsrf(i,is_sic)
-      ELSE
-       zx_tmp_fi2d(i) = 1.E+20
-      ENDIF
-      ENDDO
-      CALL histwrite_phy(nid_files(iff),"slab_bils",itau_w,zx_tmp_fi2d)
-      ENDIF
-
-      IF (flag_tslab(iff)<=lev_files(iff)) THEN
-      DO i=1, klon
-       IF(pctsrf(i,is_oce).GT.epsfra.OR.
-     $    pctsrf(i,is_sic).GT.epsfra) THEN
-        zx_tmp_fi2d(i)=tslab(i)
-       ELSE
-        zx_tmp_fi2d(i) = 1.E+20
-       ENDIF
-      ENDDO !i=1, klon
-      CALL histwrite_phy(nid_files(iff),"tslab",itau_w,zx_tmp_fi2d)
-      ENDIF
-
-      IF (flag_seaice(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"seaice",itau_w,seaice)
-      ENDIF
-
-      IF (flag_siceh(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"siceh",itau_w, seaice/1000.)
-      ENDIF
-      ENDIF !OCEAN.EQ.force/slab
+ 
+      ELSE IF (type_ocean=='slab  ') THEN
+
+      IF ( flag_slab_bils(iff)<=lev_files(iff)) 
+     $     CALL histwrite_phy(
+     $     nid_files(iff),"slab_wbils_oce",itau_w,slab_wfbils)
+
+      ENDIF !type_ocean == force/slab
 
       IF (flag_weakinv(iff)<=lev_files(iff)) THEN
Index: LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/physiq.F	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/physiq.F	(revision 996)
@@ -24,12 +24,8 @@
       USE vampir
       USE pbl_surface_mod, ONLY : pbl_surface
-      USE surface_data,     ONLY : ocean, ok_veget
+      USE change_srf_frac_mod
+      USE surface_data,     ONLY : type_ocean, ok_veget
       USE phys_local_var_mod ! Variables internes non sauvegardees de la physique
       USE phys_state_var_mod ! Variables sauvegardees de la physique
-
-
-      USE ocean_slab_mod, ONLY   : ocean_slab_get_vars
-      USE ocean_cpl_mod, ONLY    : ocean_cpl_get_vars
-      USE ocean_forced_mod, ONLY : ocean_forced_get_vars
       USE fonte_neige_mod, ONLY  : fonte_neige_get_vars
       USE phys_output_mod
@@ -120,9 +116,4 @@
       LOGICAL, SAVE :: rnpb=.TRUE.
 c$OMP THREADPRIVATE(rnpb)
-cIM "slab" ocean
-      REAL tslab(klon)    !Temperature du slab-ocean
-      REAL seaice(klon)   !glace de mer (kg/m2) 
-      REAL fluxo(klon)    !flux turbulents ocean-glace de mer 
-      REAL fluxg(klon)    !flux turbulents ocean-atmosphere
       REAL amn, amx
       INTEGER igout
@@ -699,4 +690,6 @@
       REAL wfbils(klon,nbsrf) ! bilan de chaleur au sol, pour chaque
 C                             ! type de sous-surface et pondere par la fraction
+      REAL slab_wfbils(klon)  ! bilan de chaleur au sol pour le cas de slab, sur les points d'ocean
+
       REAL fder(klon)         
       REAL ve(klon) ! integr. verticale du transport meri. de l'energie
@@ -715,8 +708,4 @@
       SAVE lmt_pas                ! frequence de mise a jour
 c$OMP THREADPRIVATE(lmt_pas) 
-cIM
-      REAL pctsrf_new(klon,nbsrf) !pourcentage surfaces issus d'ORCHIDEE
-
-cym      SAVE pctsrf                 ! sous-fraction du sol
 
 cIM sorties
@@ -1239,5 +1228,5 @@
 c appel a la lecture du run.def physique
 c
-         call conf_phys(ocean, ok_veget, ok_journe, ok_mensuel,
+         call conf_phys(ok_journe, ok_mensuel,
      .                  ok_instan, ok_hf,
      .                  solarlong0,seuil_inversion,
@@ -1279,5 +1268,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-         CALL phyetat0 ("startphy.nc",ocean, ok_veget,clesphy0,tabcntr0)
+         CALL phyetat0 ("startphy.nc",clesphy0,tabcntr0)
 cIM begin
           print*,'physiq: clwcon rnebcon ratqs',clwcon(1,1),rnebcon(1,1)
@@ -1288,16 +1277,4 @@
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
-
-       DO i=1,klon
-         IF ( abs( pctsrf(i, is_ter) + pctsrf(i, is_lic) + 
-     $       pctsrf(i, is_oce) + pctsrf(i, is_sic)  - 1.) .GT. EPSFRA) 
-     $       THEN 
-            WRITE(*,*)
-     $   'physiq apres lecture de restart: pb sous surface au point ',
-     $   i, pctsrf(i, 1 : nbsrf)
-         ENDIF 
-      ENDDO
-
 c
 C on remet le calendrier a zero
@@ -1518,5 +1495,5 @@
        call phys_output_open(jjmp1,nqmax,nlevSTD,clevSTD,nbteta, 
      &                        ctetaSTD,dtime,presnivs,ok_veget,
-     &                        ocean,iflag_pbl,ok_mensuel,ok_journe,
+     &                        type_ocean,iflag_pbl,ok_mensuel,ok_journe,
      &                        ok_hf,ok_instan,nid_files)
 c$OMP END MASTER
@@ -1581,7 +1558,22 @@
 c
       ENDIF
-c
-c   ****************     Fin  de   IF ( debut  )   ***************
-c
+!
+!   ****************     Fin  de   IF ( debut  )   ***************
+!
+!
+! Incrementer le compteur de la physique
+!
+      itap   = itap + 1
+      julien = MOD(NINT(xjour),360)
+      if (julien .eq. 0) julien = 360
+
+!
+! Update fraction of the sub-surfaces (pctsrf) and 
+! initialize, where a new fraction has appeared, all variables depending 
+! on the surface fraction.
+!
+      CALL change_srf_frac(itap, dtime, julien, 
+     *     pctsrf, falb1, falb2, ftsol, u10m, v10m, pbl_tke)
+
 
 ! Tendances bidons pour les processus qui n'affectent pas certaines
@@ -1725,10 +1717,4 @@
 cIM END
 c
-c Incrementer le compteur de la physique
-c
-      itap   = itap + 1
-      julien = MOD(NINT(xjour),360)
-      if (julien .eq. 0) julien = 360
-c
 c Mettre en action les conditions aux limites (albedo, sst, etc.).
 c Prescrire l'ozone et calculer l'albedo sur l'ocean.
@@ -1836,5 +1822,5 @@
      s     zxtsol,    zxfluxlat, zt2m,    qsat2m, 
      s     d_t_vdf,   d_q_vdf,   d_u_vdf, d_v_vdf,
-     s     ycoefh,    pctsrf_new,                
+     s     ycoefh,    slab_wfbils,                
      d     qsol,      zq2m,      s_pblh,  s_lcl,
      d     s_capCL,   s_oliqCL,  s_cteiCL,s_pblT,
@@ -1847,7 +1833,5 @@
      -     dsens,     devap,     zxsnow,
      -     zxfluxt,   zxfluxq,   q2m,     fluxq, pbl_tke )
-c
-c
-      pctsrf(:,:) = pctsrf_new(:,:)
+
       
 !-----------------------------------------------------------------------------------------
@@ -3332,15 +3316,4 @@
      .     zxfqcalving, zxfqfonte, zxffonte)
 
-      IF (ocean == 'slab') THEN
-         ! Get some variables from module ocean_slab_mod
-         CALL ocean_slab_get_vars(tslab, seaice, fluxo, fluxg)
-      ELSEIF (ocean == 'couple') THEN
-         ! Get some variables from module ocean_cpl_mod
-         CALL ocean_cpl_get_vars(fluxo, fluxg)
-      ELSE 
-         ! Get some variables from module ocean_forced_mod
-         CALL ocean_forced_get_vars(fluxo, fluxg)
-      ENDIF
-
 
 c Commente par abderrahmane le 11 2 08
Index: LMDZ4/trunk/libf/phylmd/soil.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/soil.F90	(revision 996)
+++ LMDZ4/trunk/libf/phylmd/soil.F90	(revision 996)
@@ -0,0 +1,278 @@
+!
+! $Header$
+!
+SUBROUTINE soil(ptimestep, indice, knon, snow, ptsrf, &
+     ptsoil, pcapcal, pfluxgrd)
+  
+  USE dimphy
+  USE mod_phys_lmdz_para
+  IMPLICIT NONE
+
+!=======================================================================
+!
+!   Auteur:  Frederic Hourdin     30/01/92
+!   -------
+!
+!   Object:  Computation of : the soil temperature evolution
+!   -------                   the surfacic heat capacity "Capcal"
+!                            the surface conduction flux pcapcal
+!
+!
+!   Method: Implicit time integration
+!   -------
+!   Consecutive ground temperatures are related by:
+!           T(k+1) = C(k) + D(k)*T(k)  (*)
+!   The coefficients C and D are computed at the t-dt time-step.
+!   Routine structure:
+!   1) C and D coefficients are computed from the old temperature
+!   2) new temperatures are computed using (*)
+!   3) C and D coefficients are computed from the new temperature
+!      profile for the t+dt time-step
+!   4) the coefficients A and B are computed where the diffusive
+!      fluxes at the t+dt time-step is given by
+!             Fdiff = A + B Ts(t+dt)
+!      or     Fdiff = F0 + Capcal (Ts(t+dt)-Ts(t))/dt
+!             with F0 = A + B (Ts(t))
+!                 Capcal = B*dt
+!           
+!   Interface:
+!   ----------
+!
+!   Arguments:
+!   ----------
+!   ptimestep            physical timestep (s)
+!   indice               sub-surface index
+!   snow(klon)           snow
+!   ptsrf(klon)          surface temperature at time-step t (K)
+!   ptsoil(klon,nsoilmx) temperature inside the ground (K)
+!   pcapcal(klon)        surfacic specific heat (W*m-2*s*K-1)
+!   pfluxgrd(klon)       surface diffusive flux from ground (Wm-2)
+!   
+!=======================================================================
+  INCLUDE "YOMCST.h"
+  INCLUDE "dimsoil.h"
+  INCLUDE "indicesol.h"
+  INCLUDE "comsoil.h"
+!-----------------------------------------------------------------------
+! Arguments
+! ---------
+  REAL, INTENT(IN)                     :: ptimestep
+  INTEGER, INTENT(IN)                  :: indice, knon
+  REAL, DIMENSION(klon), INTENT(IN)    :: snow
+  REAL, DIMENSION(klon), INTENT(IN)    :: ptsrf
+  
+  REAL, DIMENSION(klon,nsoilmx), INTENT(INOUT) :: ptsoil
+  REAL, DIMENSION(klon), INTENT(OUT)           :: pcapcal
+  REAL, DIMENSION(klon), INTENT(OUT)           :: pfluxgrd
+
+!-----------------------------------------------------------------------
+! Local variables
+! ---------------
+  INTEGER                             :: ig, jk, ierr
+  REAL                                :: min_period,dalph_soil
+  REAL, DIMENSION(nsoilmx)            :: zdz2
+  REAL                                :: z1s
+  REAL, DIMENSION(klon)               :: ztherm_i
+  REAL, DIMENSION(klon,nsoilmx,nbsrf) :: C_coef, D_coef
+
+! Local saved variables
+! ---------------------
+  REAL, SAVE                     :: lambda
+!$OMP THREADPRIVATE(lambda)
+  REAL, DIMENSION(nsoilmx), SAVE :: dz1, dz2
+!$OMP THREADPRIVATE(dz1,dz2)
+  LOGICAL, SAVE                  :: firstcall=.TRUE.
+!$OMP THREADPRIVATE(firstcall)
+    
+!-----------------------------------------------------------------------
+!   Depthts:
+!   --------
+  REAL fz,rk,fz1,rk1,rk2
+  fz(rk)=fz1*(dalph_soil**rk-1.)/(dalph_soil-1.)
+
+
+!-----------------------------------------------------------------------
+! Calculation of some constants
+! NB! These constants do not depend on the sub-surfaces
+!-----------------------------------------------------------------------
+
+  IF (firstcall) THEN
+!-----------------------------------------------------------------------
+!   ground levels 
+!   grnd=z/l where l is the skin depth of the diurnal cycle:
+!-----------------------------------------------------------------------
+
+     min_period=1800. ! en secondes
+     dalph_soil=2.    ! rapport entre les epaisseurs de 2 couches succ.
+!$OMP MASTER
+     IF (is_mpi_root) THEN
+        OPEN(99,file='soil.def',status='old',form='formatted',iostat=ierr)
+        IF (ierr == 0) THEN ! Read file only if it exists
+           READ(99,*) min_period
+           READ(99,*) dalph_soil
+           PRINT*,'Discretization for the soil model'
+           PRINT*,'First level e-folding depth',min_period, &
+                '   dalph',dalph_soil
+           CLOSE(99)
+        END IF
+     ENDIF
+!$OMP END MASTER
+     CALL bcast(min_period)
+     CALL bcast(dalph_soil)
+
+!   la premiere couche represente un dixieme de cycle diurne
+     fz1=SQRT(min_period/3.14)
+     
+     DO jk=1,nsoilmx
+        rk1=jk
+        rk2=jk-1
+        dz2(jk)=fz(rk1)-fz(rk2)
+     ENDDO
+     DO jk=1,nsoilmx-1
+        rk1=jk+.5
+        rk2=jk-.5
+        dz1(jk)=1./(fz(rk1)-fz(rk2))
+     ENDDO
+     lambda=fz(.5)*dz1(1)
+     PRINT*,'full layers, intermediate layers (seconds)'
+     DO jk=1,nsoilmx
+        rk=jk
+        rk1=jk+.5
+        rk2=jk-.5
+        PRINT *,'fz=', &
+             fz(rk1)*fz(rk2)*3.14,fz(rk)*fz(rk)*3.14
+     ENDDO
+
+     firstcall =.FALSE.
+  END IF
+
+
+!-----------------------------------------------------------------------
+!   Calcul de l'inertie thermique a partir de la variable rnat.
+!   on initialise a inertie_ice meme au-dessus d'un point de mer au cas 
+!   ou le point de mer devienne point de glace au pas suivant
+!   on corrige si on a un point de terre avec ou sans glace
+!
+!-----------------------------------------------------------------------
+  IF (indice == is_sic) THEN
+     DO ig = 1, knon
+        ztherm_i(ig)   = inertie_ice
+        IF (snow(ig) > 0.0) ztherm_i(ig)   = inertie_sno
+     ENDDO
+  ELSE IF (indice == is_lic) THEN
+     DO ig = 1, knon
+        ztherm_i(ig)   = inertie_ice
+        IF (snow(ig) > 0.0) ztherm_i(ig)   = inertie_sno
+     ENDDO
+  ELSE IF (indice == is_ter) THEN
+     DO ig = 1, knon
+        ztherm_i(ig)   = inertie_sol
+        IF (snow(ig) > 0.0) ztherm_i(ig)   = inertie_sno
+     ENDDO
+  ELSE IF (indice == is_oce) THEN
+     DO ig = 1, knon
+        ztherm_i(ig)   = inertie_ice
+     ENDDO
+  ELSE
+     PRINT*, "valeur d indice non prevue", indice
+     CALL abort
+  ENDIF
+
+
+!-----------------------------------------------------------------------
+! 1)
+! Calculation of Cgrf and Dgrd coefficients using soil temperature from 
+! previous time step.
+!
+! These variables are recalculated on the local compressed grid instead 
+! of saved in restart file.
+!-----------------------------------------------------------------------
+  DO jk=1,nsoilmx
+     zdz2(jk)=dz2(jk)/ptimestep
+  ENDDO
+  
+  DO ig=1,knon
+     z1s = zdz2(nsoilmx)+dz1(nsoilmx-1)
+     C_coef(ig,nsoilmx-1,indice)= &
+          zdz2(nsoilmx)*ptsoil(ig,nsoilmx)/z1s
+     D_coef(ig,nsoilmx-1,indice)=dz1(nsoilmx-1)/z1s
+  ENDDO
+  
+  DO jk=nsoilmx-1,2,-1
+     DO ig=1,knon
+        z1s = 1./(zdz2(jk)+dz1(jk-1)+dz1(jk) &
+             *(1.-D_coef(ig,jk,indice)))
+        C_coef(ig,jk-1,indice)= &
+             (ptsoil(ig,jk)*zdz2(jk)+dz1(jk)*C_coef(ig,jk,indice)) * z1s
+        D_coef(ig,jk-1,indice)=dz1(jk-1)*z1s
+     ENDDO
+  ENDDO
+
+!-----------------------------------------------------------------------
+! 2)
+! Computation of the soil temperatures using the Cgrd and Dgrd
+! coefficient computed above
+!
+!-----------------------------------------------------------------------
+
+!    Surface temperature
+  DO ig=1,knon
+     ptsoil(ig,1)=(lambda*C_coef(ig,1,indice)+ptsrf(ig))/  &
+          (lambda*(1.-D_coef(ig,1,indice))+1.)
+  ENDDO
+  
+!   Other temperatures
+  DO jk=1,nsoilmx-1
+     DO ig=1,knon
+        ptsoil(ig,jk+1)=C_coef(ig,jk,indice)+D_coef(ig,jk,indice) &
+             *ptsoil(ig,jk)
+     ENDDO
+  ENDDO
+
+  IF (indice == is_sic) THEN
+     DO ig = 1 , knon
+        ptsoil(ig,nsoilmx) = RTT - 1.8
+     END DO
+  ENDIF
+
+!-----------------------------------------------------------------------
+! 3)
+! Calculate the Cgrd and Dgrd coefficient corresponding to actual soil 
+! temperature
+!-----------------------------------------------------------------------
+  DO ig=1,knon
+     z1s = zdz2(nsoilmx)+dz1(nsoilmx-1)
+     C_coef(ig,nsoilmx-1,indice) = zdz2(nsoilmx)*ptsoil(ig,nsoilmx)/z1s
+     D_coef(ig,nsoilmx-1,indice) = dz1(nsoilmx-1)/z1s
+  ENDDO
+  
+  DO jk=nsoilmx-1,2,-1
+     DO ig=1,knon
+        z1s = 1./(zdz2(jk)+dz1(jk-1)+dz1(jk) &
+             *(1.-D_coef(ig,jk,indice)))
+        C_coef(ig,jk-1,indice) = &
+             (ptsoil(ig,jk)*zdz2(jk)+dz1(jk)*C_coef(ig,jk,indice)) * z1s
+        D_coef(ig,jk-1,indice) = dz1(jk-1)*z1s
+     ENDDO
+  ENDDO
+
+!-----------------------------------------------------------------------
+! 4)
+! Computation of the surface diffusive flux from ground and
+! calorific capacity of the ground
+!-----------------------------------------------------------------------
+  DO ig=1,knon
+     pfluxgrd(ig) = ztherm_i(ig)*dz1(1)* &
+          (C_coef(ig,1,indice)+(D_coef(ig,1,indice)-1.)*ptsoil(ig,1))
+     pcapcal(ig)  = ztherm_i(ig)* &
+          (dz2(1)+ptimestep*(1.-D_coef(ig,1,indice))*dz1(1))
+     z1s = lambda*(1.-D_coef(ig,1,indice))+1.
+     pcapcal(ig)  = pcapcal(ig)/z1s
+     pfluxgrd(ig) = pfluxgrd(ig) &
+          + pcapcal(ig) * (ptsoil(ig,1) * z1s &
+          - lambda * C_coef(ig,1,indice) &
+          - ptsrf(ig)) &
+          /ptimestep
+  ENDDO
+    
+END SUBROUTINE soil
Index: LMDZ4/trunk/libf/phylmd/surf_land_bucket_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/surf_land_bucket_mod.F90	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/surf_land_bucket_mod.F90	(revision 996)
@@ -8,10 +8,4 @@
 ! This module is used when no external land model is choosen.
 !
-  USE fonte_neige_mod
-  USE calcul_fluxs_mod
-  USE dimphy
-  USE mod_grid_phy_lmdz
-  USE mod_phys_lmdz_para
- 
   IMPLICIT NONE
 
@@ -26,4 +20,12 @@
        fluxsens, fluxlat, tsurf_new, dflux_s, dflux_l)
 
+    USE limit_read_mod
+    USE surface_data
+    USE fonte_neige_mod
+    USE calcul_fluxs_mod
+    USE cpl_mod
+    USE dimphy
+    USE mod_grid_phy_lmdz
+    USE mod_phys_lmdz_para
 !****************************************************************************************
 ! Bucket calculations for surface. 
@@ -74,4 +76,5 @@
     REAL, DIMENSION(klon) :: zfra
     REAL, DIMENSION(klon) :: radsol       ! total net radiance at surface
+    REAL, DIMENSION(klon) :: dummy_riverflow,dummy_coastalflow 
     INTEGER               :: i
 !
@@ -82,8 +85,7 @@
 !* Read from limit.nc : albedo(alb_lim), length of rugosity(z0_new)
 !
-    CALL interfsur_lim(itime, dtime, jour, &
-         knon, knindex, debut,  &
-         alb_lim, z0_new)
-    
+    CALL limit_read_rug_alb(itime, dtime, jour,&
+         knon, knindex, &
+         z0_new, alb_lim)
 !
 !* Calcultaion of fluxes 
@@ -145,6 +147,18 @@
 !* Calculate the rugosity
 !
-    z0_new = SQRT(z0_new**2+rugoro**2)
-       
+    DO i = 1, knon
+       z0_new(i) = SQRT(z0_new(i)**2+rugoro(i)**2)
+    END DO
+
+!* Send to coupler
+!  The run-off from river and coast are not calculated in the bucket modele.
+!  For testing purpose of the coupled modele we put the run-off to zero.
+    IF (type_ocean=='couple') THEN
+       dummy_riverflow(:)   = 0.0
+       dummy_coastalflow(:) = 0.0
+       CALL cpl_send_land_fields(itime, knon, knindex, &
+            dummy_riverflow, dummy_coastalflow)
+    ENDIF
+
 !
 !* End
@@ -154,176 +168,3 @@
 !****************************************************************************************
 !
-  SUBROUTINE interfsur_lim(itime, dtime, jour, &
-       knon, knindex, debut, &
-       lmt_alb_p, lmt_rug_p)
-    
-! Cette routine sert d'interface entre le modele atmospherique et un fichier
-! de conditions aux limites
-!
-! L. Fairhead 02/2000
-!
-! input:
-!   itime        numero du pas de temps courant
-!   dtime        pas de temps de la physique (en s)
-!   jour         jour a lire dans l'annee
-!   knon         nombre de points dans le domaine a traiter
-!   knindex      index des points de la surface a traiter
-!   debut        logical: 1er appel a la physique (initialisation)
-!
-! output:
-!   lmt_alb_p      Albedo lu 
-!   lmt_rug_p      longueur de rugosite lue
-
-    INCLUDE "netcdf.inc"
-
-! Input variables
-!****************************************************************************************
-    INTEGER, INTENT(IN)                      :: itime
-    REAL   , INTENT(IN)                      :: dtime
-    INTEGER, INTENT(IN)                      :: jour
-    INTEGER, INTENT(IN)                      :: knon
-    INTEGER, DIMENSION(klon_loc), INTENT(IN) :: knindex
-    LOGICAL, INTENT(IN)                      :: debut
-
-! Output variables
-!****************************************************************************************
-    REAL, INTENT(out), DIMENSION(klon_loc)   :: lmt_alb_p
-    REAL, INTENT(out), DIMENSION(klon_loc)   :: lmt_rug_p
-
-! Local variables with attribute SAVE
-!****************************************************************************************
-    INTEGER,SAVE   :: lmt_pas     ! frequence de lecture des conditions limites 
-                                  ! (en pas de physique)
-    !$OMP THREADPRIVATE(lmt_pas) 
-    LOGICAL,SAVE   :: deja_lu_sur ! pour indiquer que le jour a lire a deja
-                                  ! lu pour une surface precedente
-    !$OMP THREADPRIVATE(deja_lu_sur) 
-    INTEGER,SAVE                           :: jour_lu_sur 
-    !$OMP THREADPRIVATE(jour_lu_sur) 
-    CHARACTER (len = 20),SAVE              :: fich ='limit.nc'
-    !$OMP THREADPRIVATE(fich) 
-    LOGICAL,SAVE                           :: check = .FALSE.
-    !$OMP THREADPRIVATE(check) 
-! Champs lus dans le fichier de CL
-    REAL, ALLOCATABLE , SAVE, DIMENSION(:) :: alb_lu_p, rug_lu_p
-    !$OMP THREADPRIVATE(alb_lu_p, rug_lu_p) 
-
-! quelques variables pour netcdf
-    INTEGER ,SAVE                          :: nid, nvarid
-    !$OMP THREADPRIVATE(nid, nvarid) 
-    INTEGER, DIMENSION(2),SAVE             :: start, epais
-    !$OMP THREADPRIVATE(start, epais) 
-
-! Other local variables
-!****************************************************************************************
-    INTEGER                                :: ii, ierr
-    CHARACTER (len = 20)                   :: modname = 'interfsur_lim'
-    CHARACTER (len = 80)                   :: abort_message
-    REAL, DIMENSION(klon_glo)              :: alb_lu
-    REAL, DIMENSION(klon_glo)              :: rug_lu
-
-!
-! End delaration
-!****************************************************************************************
-
-    IF (debut) THEN
-       lmt_pas = NINT(86400./dtime * 1.0) ! pour une lecture une fois par jour
-       jour_lu_sur = jour - 1
-       ALLOCATE(alb_lu_p(klon_loc))
-       ALLOCATE(rug_lu_p(klon_loc))
-    ENDIF
-    
-    IF ((jour - jour_lu_sur) /= 0) deja_lu_sur = .FALSE.
-  
-    IF (check) WRITE(*,*) modname,':: jour_lu_sur, deja_lu_sur', jour_lu_sur, deja_lu_sur 
-    IF (check) WRITE(*,*) modname,':: itime, lmt_pas', itime, lmt_pas
-    IF (check) CALL flush(6)
-
-!    
-! Tester d'abord si c'est le moment de lire le fichier
-!
-    IF (MOD(itime-1, lmt_pas) == 0 .AND. .NOT. deja_lu_sur) THEN
-
-!
-! Ouverture et lecture du fichier
-!
-!$OMP MASTER
-       IF (is_mpi_root) THEN
-          fich = TRIM(fich)
-          IF (check) WRITE(*,*)modname,' ouverture fichier ',fich
-          IF (check) CALL flush(6)
-          ierr = NF_OPEN (fich, NF_NOWRITE,nid)
-          IF (ierr.NE.NF_NOERR) THEN
-             abort_message = 'Pb d''ouverture du fichier de conditions aux limites'
-             CALL abort_gcm(modname,abort_message,1)
-          ENDIF
-! 
-! La tranche de donnees a lire:
-          start(1) = 1
-          start(2) = jour
-          epais(1) = klon_glo
-          epais(2) = 1
-!
-! Lecture albedo
-          ierr = NF_INQ_VARID(nid, 'ALB', nvarid)
-          IF (ierr /= NF_NOERR) THEN
-             abort_message = 'Le champ <ALB> est absent'
-             CALL abort_gcm(modname,abort_message,1)
-          ENDIF
-#ifdef NC_DOUBLE
-          ierr = NF_GET_VARA_DOUBLE(nid,nvarid,start,epais, alb_lu)
-#else
-          ierr = NF_GET_VARA_REAL(nid,nvarid,start,epais, alb_lu)
-#endif
-          IF (ierr /= NF_NOERR) THEN
-             abort_message = 'Lecture echouee pour <ALB>'
-             CALL abort_gcm(modname,abort_message,1)
-          ENDIF
-!
-! Lecture rugosite!
-          ierr = NF_INQ_VARID(nid, 'RUG', nvarid)
-          IF (ierr /= NF_NOERR) THEN
-             abort_message = 'Le champ <RUG> est absent'
-             CALL abort_gcm(modname,abort_message,1)
-          ENDIF
-#ifdef NC_DOUBLE
-          ierr = NF_GET_VARA_DOUBLE(nid,nvarid,start,epais, rug_lu)
-#else
-          ierr = NF_GET_VARA_REAL(nid,nvarid,start,epais, rug_lu)
-#endif
-          IF (ierr /= NF_NOERR) THEN
-             abort_message = 'Lecture echouee pour <RUG>'
-             CALL abort_gcm(modname,abort_message,1)
-          ENDIF
-
-!
-! Fin de lecture
-          ierr = NF_CLOSE(nid)
-
-       ENDIF ! is_mpi_root
-!$OMP END MASTER
-
-       CALL Scatter(alb_lu,alb_lu_p)
-       CALL Scatter(rug_lu,rug_lu_p)
-
-       deja_lu_sur = .TRUE.
-       jour_lu_sur = jour       
-
-    ENDIF
-  
-!
-! Recopie des variables dans les champs de sortie
-!
-    lmt_alb_p(:) = 999999.
-    lmt_rug_p(:) = 999999.
-    DO ii = 1, knon
-       lmt_alb_p(ii) = alb_lu_p(knindex(ii))
-       lmt_rug_p(ii) = rug_lu_p(knindex(ii))
-    ENDDO
-    
-
-  END SUBROUTINE interfsur_lim
-!
-!****************************************************************************************
-!
 END MODULE surf_land_bucket_mod
Index: LMDZ4/trunk/libf/phylmd/surf_land_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/surf_land_mod.F90	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/surf_land_mod.F90	(revision 996)
@@ -26,5 +26,5 @@
        snow, qsol, agesno, tsoil, &
        z0_new, alb1_new, alb2_new, evap, fluxsens, fluxlat, &
-       qsurf, tsurf_new, dflux_s, dflux_l, pctsrf_ter, &
+       qsurf, tsurf_new, dflux_s, dflux_l, &
        lwdown_m)
 
@@ -75,5 +75,4 @@
     REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
     REAL, DIMENSION(klon), INTENT(OUT)       :: dflux_s, dflux_l      
-    REAL, DIMENSION(klon), INTENT(OUT)       :: pctsrf_ter
 
 ! Local variables
@@ -154,11 +153,4 @@
     ENDIF ! ok_veget
 
-!****************************************************************************************
-! Return the pourcentage of land in each grid cell, even if not changed in here!
-!
-!****************************************************************************************
-    pctsrf_ter(:) = pctsrf(:,is_ter)
-
-
   END SUBROUTINE surf_land
 !
Index: LMDZ4/trunk/libf/phylmd/surf_land_orchidee_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/surf_land_orchidee_mod.F90	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/surf_land_orchidee_mod.F90	(revision 996)
@@ -15,5 +15,5 @@
   USE intersurf     ! module d'ORCHIDEE
   USE cpl_mod,      ONLY : cpl_send_land_fields
-  USE surface_data, ONLY : ocean, ok_veget
+  USE surface_data, ONLY : type_ocean
   USE comgeomphy,   ONLY : cuphy, cvphy
   USE mod_grid_phy_lmdz
@@ -199,5 +199,4 @@
 
     IF (check) WRITE(lunout,*)'Entree ', modname
-    IF (check) WRITE(lunout,*)'ok_veget = ',ok_veget
   
 ! Initialisation
@@ -416,5 +415,5 @@
 !* Send to coupler
 !
-    IF (ocean=='couple') THEN
+    IF (type_ocean=='couple') THEN
        CALL cpl_send_land_fields(itime, knon, knindex, &
             riverflow, coastalflow)
